## libatomic-queue 0.0%2Bgit20201108.d9d66b6

=== debian/changelog ===
libatomic-queue (0.0+git20201108.d9d66b6-2) unstable; urgency=high

  * Team upload.
  * Don't build with -m{arch,tune}=native. Closes: #987532
  * debian/rules: build and run upstream's tests
  * Set upstream metadata fields: Repository, Repository-Browse.
  * Add autopkgtests
  * debian/libatomic-queue0.symbols: add missing Build-Depends-Package
    meta-information field
  * debian/control: add missing deps for the -dev package

 -- Michael R. Crusoe <crusoe@debian.org>  Sun, 25 Apr 2021 14:39:37 +0200

libatomic-queue (0.0+git20201108.d9d66b6-1) unstable; urgency=medium

  * New upstream commit
  * Versioned Build-Depends: libxenium-dev (>= 0.0.2+ds-2~)
    Closes: #976481
  * New upstream version
  * Standards-Version: 4.5.1 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Remove trailing whitespace in debian/rules (routine-update)
  * Trim trailing whitespace.
  * Set upstream metadata fields: Bug-Database, Bug-Submit.
  * Remove Section on libatomic-queue0 that duplicates source.

 -- Andreas Tille <tille@debian.org>  Sat, 05 Dec 2020 20:51:05 +0100

libatomic-queue (0.0+git20201007.df79403-2) unstable; urgency=medium

  * Source-only-upload.

 -- Nilesh Patra <npatra974@gmail.com>  Thu, 29 Oct 2020 20:02:48 +0530

libatomic-queue (0.0+git20201007.df79403-1) unstable; urgency=medium

  * Initial release (Closes: #963829)

 -- Andreas Tille <tille@debian.org>  Tue, 27 Oct 2020 08:40:40 +0100
