=== meson_options.txt ===
option('benchmarks', type : 'boolean', value : true,
       description : 'Do not build benchmarks; ignore their dependencies')
