## libatomic-queue 0.0+git20211209.7db4cea

=== debian/changelog ===
libatomic-queue (0.0+git20211209.7db4cea-1) unstable; urgency=medium

  * New upstream version
  * Fix symbols file
    Closes: #1002253
  * Fix lintian override
  * Do not create "thin" ar archives

 -- Andreas Tille <tille@debian.org>  Wed, 22 Dec 2021 06:46:45 +0100

libatomic-queue (0.0+git20201108.d9d66b6-4) unstable; urgency=medium

  * Fix symbols (Closes: #997408)
  * Bump Standards-Version to 4.6.0 (no changes needed)

 -- Nilesh Patra <nilesh@debian.org>  Fri, 29 Oct 2021 19:36:25 +0530

libatomic-queue (0.0+git20201108.d9d66b6-3) unstable; urgency=medium

  * Team upload.

  [ Matthias Klose ]
  * Mark two more symbols as optional. Closes: #989091

  [ Michael R. Crusoe ]
  * Fix lintian-overrides
  * Adjust symbols for gcc-11. Closes: #984084

 -- Michael R. Crusoe <crusoe@debian.org>  Wed, 13 Oct 2021 12:56:34 +0200
