=== debian/control ===
--- 
+++ 
@@ -1,9 +1,10 @@
 Source: libatomic-queue
-Priority: optional
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders: Steffen Moeller <moeller@debian.org>,
            Andreas Tille <tille@debian.org>,
-           Nilesh Patra <npatra974@gmail.com>
+           Nilesh Patra <nilesh@debian.org>
+Section: libs
+Priority: optional
 Build-Depends: debhelper-compat (= 13),
                d-shlibs,
                libboost-dev,
@@ -11,12 +12,11 @@
                libconcurrentqueue-dev,
                libreaderwriterqueue-dev,
                libtbb-dev,
-               libxenium-dev (>= 0.0.2+ds-2~)
-Standards-Version: 4.5.1
-Section: libs
-Homepage: https://github.com/max0x7ba/atomic_queue
+               libxenium-dev
+Standards-Version: 4.6.0
 Vcs-Browser: https://salsa.debian.org/med-team/libatomic-queue
 Vcs-Git: https://salsa.debian.org/med-team/libatomic-queue.git
+Homepage: https://github.com/max0x7ba/atomic_queue
 Rules-Requires-Root: no
 
 Package: libatomic-queue0
@@ -59,9 +59,10 @@
  This package contains the dynamic library.
 
 Package: libatomic-queue-dev
+Architecture: any
 Section: libdevel
-Architecture: any
 Depends: libatomic-queue0 (= ${binary:Version}),
+         libboost-dev,
          ${shlibs:Depends},
          ${misc:Depends}
 Description: devel files for C++ atomic_queue library
