## libatomic-queue 0.0+git20220518.83774a2

=== debian/changelog ===
libatomic-queue (0.0+git20220518.83774a2-1) unstable; urgency=medium

  * Team upload.

  [ Andreas Tille ]
  * Exclude i386 from Salsa CI since libxenium-dev is not available

  [ Étienne Mollier ]
  * Add compiler.patch: don't erase CC and CXX environment variables.
  * d/s/lintian-overrides: update to new naming convention.
  * d/*.symbols: mark some compiler specific symbols optional.
    (Closes: #1012966)
  * Standards-Version: 4.6.1 (routine-update)

 -- Étienne Mollier <emollier@debian.org>  Fri, 01 Jul 2022 18:36:29 +0200
