=== debian/control ===
--- 
+++ 
@@ -13,7 +13,7 @@
                libreaderwriterqueue-dev,
                libtbb-dev,
                libxenium-dev
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Vcs-Browser: https://salsa.debian.org/med-team/libatomic-queue
 Vcs-Git: https://salsa.debian.org/med-team/libatomic-queue.git
 Homepage: https://github.com/max0x7ba/atomic_queue
