=== debian/rules ===
--- 
+++ 
@@ -32,3 +32,8 @@
 #dh_strip: error: Aborting due to earlier error
 override_dh_strip:
 	dh_strip || true
+
+override_dh_auto_test:
+ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
+	$(MAKE) example run_tests
+endif
