=== debian/changelog ===
libatomic-queue (1.4-2) unstable; urgency=medium

  * d/*.symbols: mark several compiler specific symbols as optional.
    (Closes: #1015472, #1075145)
  * d/rules: always run LTO builds.
  * d/control: add myself to uploaders.
  * d/control: declare compliance to standards version 4.7.0.

 -- Étienne Mollier <emollier@debian.org>  Wed, 10 Jul 2024 16:43:27 +0200

libatomic-queue (1.4-1) unstable; urgency=medium

  [ Nilesh Patra ]
  * [ci skip] Remove myself from uploaders

  [ Étienne Mollier ]
  * New upstream version.
  * Standards-Version: 4.6.2 (routine-update)
  * Remove field Section on binary package libatomic-queue0 that duplicates
    source.
  * generate-shared-library.patch: refresh.
  * no-native patch: refresh.
  * no_thin_archives.patch: refresh.
  * compiler.patch: refresh.
  * concurrentqueue.patch: new: fix include issue.
  * d/rules: build with -Wno-error=array-bounds.
    This works around gcc-13 bug [1], also Debian Bug#1041607.
    [1]: https://gcc.gnu.org/bugzilla/show_bug.cgi?id=110764 (Closes: #1037715)
  * d/watch: support tags introduced upstream.

  [ Andreas Tille ]
  * Update symbols

 -- Andreas Tille <tille@debian.org>  Fri, 25 Aug 2023 09:45:57 +0200
