=== debian/rules ===
--- 
+++ 
@@ -1,17 +1,12 @@
 #!/usr/bin/make -f
-# See debhelper(7) (uncomment to enable)
-# output every command that modifies files on the build system.
-#export DH_VERBOSE = 1
+export DEB_BUILD_MAINT_OPTIONS = optimize=+lto
 
+# Workaround gcc-13 bug.  See Gcc bug #110764[1].  FIXME: this is fixed in
+# upcoming upstream build flags[2], so won't be necessary for long.
+# [1]: https://gcc.gnu.org/bugzilla/show_bug.cgi?id=110764
+# [2]: https://github.com/max0x7ba/atomic_queue/commit/c79be00ef12a5f3dc4294ba4954194a712a2853d
+export DEB_CXXFLAGS_MAINT_APPEND  = -Wno-error=array-bounds
 
-# see FEATURE AREAS in dpkg-buildflags(1)
-#export DEB_BUILD_MAINT_OPTIONS = hardening=+all
-
-# see ENVIRONMENT in dpkg-buildflags(1)
-# package maintainers to append CFLAGS
-#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
-# package maintainers to append LDFLAGS
-#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
 
 %:
 	dh $@
