=== debian/changelog ===
libatomic-queue (1.6.5-2) unstable; urgency=medium

  * d/control: build depends on binutils-gold to pull ld.gold.
    (Closes: #1096216)
  * d/control: declare compliance to standards version 4.7.1.
  * d/patches/*: normalize Last-Update timestamp against dep3.

 -- Étienne Mollier <emollier@debian.org>  Tue, 25 Feb 2025 23:31:15 +0100

libatomic-queue (1.6.5-1) unstable; urgency=medium

  * New upstream version 1.6.5

 -- Étienne Mollier <emollier@debian.org>  Wed, 02 Oct 2024 21:08:56 +0200

libatomic-queue (1.6.4-1) unstable; urgency=medium

  * New upstream version 1.6.4
  * generate-shared-library.patch: refresh.
  * no-native: refresh patch.
  * no_thin_archives.patch: refresh.
  * compiler.patch: unfuzz.
  * fix_unused_variable.patch: unfuzz.
  * d/rules: remove workaround for gcc 13 bug.
  * d/rules: remove workaround against dh_strip failure.
  * d/rules: delete file landing in standard top directory.
  * d/control: deduplicate Section: libs field.
  * d/s/lintian-overrides: flag another source-missing false positive.

 -- Étienne Mollier <emollier@debian.org>  Fri, 23 Aug 2024 13:20:22 +0200
