=== debian/control ===
--- 
+++ 
@@ -6,6 +6,7 @@
 Section: libs
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
+               binutils-gold,
                d-shlibs,
                libboost-dev,
                libboost-test-dev,
@@ -13,7 +14,7 @@
                libreaderwriterqueue-dev,
                libtbb-dev,
                libxenium-dev
-Standards-Version: 4.7.0
+Standards-Version: 4.7.1
 Vcs-Browser: https://salsa.debian.org/med-team/libatomic-queue
 Vcs-Git: https://salsa.debian.org/med-team/libatomic-queue.git
 Homepage: https://github.com/max0x7ba/atomic_queue
@@ -21,7 +22,6 @@
 
 Package: libatomic-queue0
 Architecture: any
-Section: libs
 Depends: ${shlibs:Depends},
          ${misc:Depends}
 Description: C++ atomic_queue library
