=== debian/rules ===
#!/usr/bin/make -f
export DEB_BUILD_MAINT_OPTIONS = optimize=+lto

%:
	dh $@

override_dh_install:
	dh_install
	mv `find . -name "*.a"` `dirname $$(find . -name "*.so")`
	d-shlibmove --commit \
		    --multiarch \
		    --devunversioned \
		    --exclude-la \
		    --movedev include usr \
		    $$(find . -name "*.so")
	rm -vf debian/libatomic-queue-dev/usr/include/CMakeLists.txt

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	$(MAKE) example run_tests
endif
