=== debian/tests/control ===
Tests: run-unit-test
Depends: libatomic-queue-dev, libboost-test-dev, g++
Restrictions: allow-stderr
