=== debian/changelog ===
libatomic-queue (1.6.9-1) experimental; urgency=medium

  * New upstream version 1.6.9
  * d/control: declare compliance to standards version 4.7.2.
  * Use meson for installation, removes libatomic-queue0. (Closes: #1104583)

 -- Stephan Lachnit <stephanlachnit@debian.org>  Tue, 24 Jun 2025 20:31:53 +0200
