=== debian/changelog ===
libatomic-queue (1.7.1-1) unstable; urgency=medium

  * New upstream version 1.7.1

 -- Stephan Lachnit <stephanlachnit@debian.org>  Fri, 22 Aug 2025 11:38:23 +0200
