=== debian/tests/control ===
Tests: run-unit-test
Depends: g++, meson, pkgconf, libatomic-queue-dev, libboost-test-dev
