=== debian/watch ===
version=4
opts="mode=git,dversionmangle=auto" \
https://github.com/max0x7ba/atomic_queue.git \
refs/tags/v?([\d\.\d]+)
